/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package projetnf29;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Date;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author margauxcharles
 */
public class LaTeXtoXML {
    private final String filePathIn;
    private final String filePathOut;
    private Boolean header = true;
    private Boolean document = false;
    private Boolean chapter = false;
    private Boolean section = false;
    private Boolean subsection = false;
    private Boolean subsubsection = false;
    private Boolean paragraph = false;
    private Boolean subparagraph = false;
    private Boolean text = false;
    private BufferedReader buff;
    
    LaTeXtoXML(String inputpath, String outputpath) throws FileNotFoundException{
        filePathIn = inputpath;
        filePathOut = outputpath;
        createLaTeXML();
        loadFile();
    }
    
    public final void createLaTeXML(){
        try
        {
            File f = new File(filePathOut);
            if(f.createNewFile()){
            //System.out.println ("file created");
            FileWriter fw = new FileWriter (f);
            fw.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            //System.out.println ("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            fw.write("\n");
            fw.write("<latex>");
            //System.out.println ("<latex>");
            fw.write("\n");
            fw.close();
            }
            else{
                //System.out.println ("file not created");
            }
        }
        catch (IOException exception)
        {
            System.out.println ("Erreur lors de la lecture bla : " + exception.getMessage());
        }
    }
    
    public void writeXML(String text){
        File f = new File(filePathOut);
        try
        {   
            FileWriter fw = new FileWriter (f, true);
            fw.write (text);
            fw.write("\n");
            fw.close();
        }
        catch (IOException exception)
        {
            System.out.println ("Erreur lors de la lecture : " + exception.getMessage());
        }
    }
    
    String balise0(String balise){
        String result = "<" + balise + "/>";
        //System.out.println(result);
        writeXML(result);
        return result;
    }
    
    String balise1(String balise){
        String result = "<" + balise + ">";
        //System.out.println(result);
        writeXML(result);
        return result;
    }
    
    String balise2(String balise, String param){
        String result = "<" + balise + ">" + "<param>" + param + "</param>" + "</" + balise + ">";
        //System.out.println(result);
        writeXML(result);
        return result;
    }
    
    String balise3(String balise, String option, String param){
        String result = "<" + balise + ">" + "<option>" + option + "</option>" + "<param>" + param + "</param>" + "</" + balise + ">";
        //System.out.println(result);
        writeXML(result);
        return result;
    }
    
    String balise_end(String balise){
        String result = "</" + balise + ">";
        //System.out.println(result);
        writeXML(result);
        return result;
    }
    
    void date(String balise, String option, String param){
        if(param.equals("\\today")){
            Date d = new Date();
            balise2(balise, d.toString());
        }
        else{
            balise2(balise, param);
        }
    }
    
    void author(String balise, String option, String param){
        balise2(balise, param);
    }
    
    void title(String title){
        //System.out.println ("<title>"+ title + "</title>");
        writeXML("<title>"+ title + "</title>");
    }
    
    void maketitle(){        
        balise0("maketitle");
    }
    
    void tableofcontents(){        
        balise0("tableofcontents");
    }
    
    void listoffigures(){        
        balise0("listoffigures");
    }
    
    void document(Boolean begin){
        if(begin){
            header = false;
            document = true;
            balise1("document"); 
        }
        else{
            if(subparagraph){
                subparagraph(false, "");
            }
            if(paragraph){
                paragraph(false, "");
            }
            if(subsubsection){
               subsubsection(false, "");
            }
            if(subsection){
                subsection(false, "");
            }
            if(section){
                section(false, "");
            }
            if(chapter){
                chapter(false, "");
            }
            document = false;
            balise_end("document");
            balise_end("latex");
        }
    }
    
    void itemize_enumerate(String env) throws IOException{
        balise1(env);
        String line;
        Boolean item = false;
        String match_item;
        while(!match_end(line = buff.readLine()))
        {   
            match_item = match_item(line);
            if(match_item.isEmpty()){
                writeXML(line);
                //System.out.println(line);
            }
            else{
                if(item){
                    balise_end("item");
                }
                else{
                    item = true;
                }
                balise1("item");
                writeXML(match_item);
                //System.out.println(match_item);
            }
        }
        if(item){
            balise_end("item");
        }
        balise_end(env);
    }
    
    void itemize() throws IOException{
         itemize_enumerate("itemize");
    }
    
    void enumerate() throws IOException{
        itemize_enumerate("enumerate");
    }
    
    void description() throws IOException{
        balise1("description");
        String line;
        Boolean item = false;
        String match_item;
        while(!match_end(line = buff.readLine()))
        {   
            match_item = match_item_description(line);
            if(match_item.isEmpty()){
                writeXML(line);
                //System.out.println(line);
            }
            else{
                if(item){
                    balise_end("item");
                }
                else{
                    item = true;
                }
                balise1("item");
                writeXML(match_item);
                //System.out.println(match_item);
            }
        }
        if(item){
            balise_end("item");
        }
        balise_end("description");    
    }
    
    void tabular() throws IOException{
        balise1("tabular"); 
        String line;
        String new_line;
        Boolean row = false;
        while(!match_end(line = buff.readLine()))
        {   
            if(!row){
                row = true;
                balise1("tr"); 
                balise1("td");
            }
            new_line = match_tabular(line);
            if(new_line.contains("</tr>")){
                row = false;
            }
            writeXML(new_line);
            //System.out.println(new_line);
        }
        balise_end("tabular"); 
    }
    
    void includegraphics(String balise, String option, String param){
        balise3(balise, option, param);
    }
    
    void chapter(Boolean begin, String title){
        if(begin){
            if(chapter){
                if(subparagraph){
                    subparagraph(false, "");
                }
                if(paragraph){
                    paragraph(false, "");
                }
                if(subsubsection){
                    subsubsection(false, "");
                }
                if(subsection){
                    subsection(false, "");
                }
                if(section){
                    section(false, "");
                }
                balise_end("chapter");
                balise1("chapter");
                title(title);
            }
            else{
                chapter = true;
                balise1("chapter"); 
                title(title);
            }
        }
        else{
            balise_end("chapter");
            chapter = false;
        }
    }
    
    void section(Boolean begin, String title){
        if(begin){
            if(section){
                if(subparagraph){
                    subparagraph(false, "");
                }
                if(paragraph){
                    paragraph(false, "");
                }
                if(subsubsection){
                    subsubsection(false, "");
                }
                if(subsection){
                    subsection(false, "");
                }
                balise_end("section");
                balise1("section");
                title(title);
            }
            else{
                section = true;
                balise1("section");
                title(title);
            }
        }
        else{
            balise_end("section");
            section = false;
        }
    }
    
    void subsection(Boolean begin, String title){
        if(begin){
            if(subsection){
                if(subparagraph){
                    subparagraph(false, "");
                }
                if(paragraph){
                    paragraph(false, "");
                }
                if(subsubsection){
                    subsubsection(false, "");
                }
                balise_end("subsection");
                balise1("subsection");
                title(title);
            }
            else{
                subsection = true;
                balise1("subsection");
                title(title);
            }
        }
        else{
            balise_end("subsection");
            subsection = false;
        }   
    }
    
    void subsubsection(Boolean begin, String title){
        if(begin){
            if(subsubsection){
                if(subparagraph){
                    subparagraph(false, "");
                }
                if(paragraph){
                    paragraph(false, "");
                }
                balise_end("subsubsection");
                balise1("subsubsection");
                title(title);
            }
            else{
                subsubsection = true;
                balise1("subsubsection");
                title(title);
            }
        }
        else{
            balise_end("subsubsection");
            subsubsection = false;
        }   
    }
    
    void paragraph(Boolean begin, String title){
        if(begin){
            if(paragraph){
                if(subparagraph){
                    subparagraph(false, "");
                }
                balise_end("paragraph");
                balise1("paragraph");
                title(title);
            }
            else{
                paragraph = true;
                balise1("paragraph");
                title(title);
            }
        }
        else{
            balise_end("paragraph");
            paragraph = false;
        }
    }
    
    void subparagraph(Boolean begin, String title){
        if(begin){
            if(subparagraph){
                balise_end("subparagraph");
                balise1("subparagraph");
                title(title);
            }
            else{
                subparagraph = true;
                balise1("subparagraph");
                title(title);
            }
        }
        else{
            balise_end("subparagraph");
            subparagraph = false;               
        }
    }
    
    void begin(String param) throws IOException{
        if(param.equals("document")){
            document(true);
        }
        if(param.equals("itemize")){
            itemize();
        }
        if(param.equals("enumerate")){
            enumerate();
        }
        if(param.equals("description")){
            description();
        }
        if(param.equals("tabular")){
            tabular();
        }
    }
    
    void end(String param) throws IOException{
        if(param.equals("document")){
            document(false);
        }
    }
    
    Boolean match_end(String line){
        Pattern p = Pattern.compile("\\\\end");
        Matcher m = p.matcher(line);
        return m.find();
    }
    
    String match_item(String line){
        Pattern p = Pattern.compile("\\\\item ([\\a-zA-Z\"+ :-_()êâïëäôéèàç0-9.]+)");
        Matcher m = p.matcher(line);
        String new_line = "";
        String g1;
        if(m.find()){
            g1 = m.group(1);
            new_line = g1;
        }
        return new_line;
    }
    
    String match_item_description(String line){
        Pattern p = Pattern.compile("\\\\item\\[([a-zA-Z0-9-: =.]*)\\] ([\\a-zA-Z\"+ :-_()êâïëäôéèàç0-9.]+)");
        Matcher m = p.matcher(line);
        String new_line = "";
        String g1;
        String g2;
        if(m.find()){
            g1 = m.group(1);
            g2 = m.group(2);
            new_line = g1 + " " + g2;
        }
        return new_line;
    }
    
    String match_tabular(String line){
        String new_line;
        new_line = line.replace("\\\\", "</td> </tr>");
        new_line = new_line.replace("&", "</td> <td>");
        new_line = new_line.replace("\\hline", "");
        return new_line;
    }
    
    String text(String line){
        String new_line;
        if(line.endsWith("\\")){
            new_line = line.replace("\\", "");
        }
        else{
            new_line = line;
        }
        return new_line;
    }
    
    Matcher match_balise(String line){
        Pattern p = Pattern.compile("\\\\([a-z]+)\\[?([a-zA-Z0-9=. ]*)\\]?\\{?([ \\a-z\"+-A-Zéèàç0-9?!.]*)\\}?");
        Matcher m = p.matcher(line);
        return m;
    }
    
    void lineAnalyze(String line) throws IOException{
        // Balises du type \balise[options]{param}
        Matcher m = match_balise(line);
        
        if(m.find()){ // Si il s'agit d'une balise
            String balise = m.group(1);
            String option = m.group(2);
            String param = m.group(3);
            
            if(text){
                //System.out.println("</text>");
                writeXML("</text>");
                text = false;
            }
            if(!balise.isEmpty() & option.isEmpty() & param.isEmpty()){
                balise0(balise);
            }
            if(balise.equals("author")){
                author(balise, option, param);
            }
            if(balise.equals("title")){
                title(param);
            }
            if(balise.equals("date")){
                date(balise, option, param);
            }
            if(balise.equals("includegraphics")){
                includegraphics(balise, option, param);
            }
            if(balise.equals("chapter")){
                chapter(true, param);
            }
            if(balise.equals("section")){
                section(true, param);
            }
            if(balise.equals("subsection")){
                subsection(true, param);
            }
            if(balise.equals("subsubsection")){
                subsubsection(true, param);
            }
            if(balise.equals("paragraph")){
                paragraph(true, param);
            }
            if(balise.equals("subparagraph")){
                subparagraph(true, param);
            }
            if(balise.equals("begin")){
                begin(param);
            }
            if(balise.equals("end")){
                end(param);
            }
        }
        else{ // Si il ne s'agit pas d'une balise 
            if(!line.isEmpty()){
                if(text){
            //System.out.println(text(line));
            writeXML(text(line));
            }
            else{
                //System.out.println("<text>");
                writeXML("<text>");
                //System.out.println(text(line));
                writeXML(text(line));  
                text = true;
            }
                
            }
            
        }
            
    }
    
    
    public final void loadFile() throws FileNotFoundException{
        try{
            buff = new BufferedReader(new FileReader(filePathIn));
            try {
                String line;

                while ((line = buff.readLine()) != null) {
                    if(!line.startsWith("%")){
                        lineAnalyze(line);
                    }
                }
            } finally {
                buff.close();
            }
        } catch (IOException ioe) {
            System.out.println("Erreur ici --" + ioe.toString());
        }
    }
}